package jp.gr.java_conf.abagames.brick;

import jp.gr.java_conf.abagames.util.MessageManager;
import gl4java.*;

/**
  Bong boot class
  */
public class Brick {

  public Brick(String[] args) {
    try {
      if ( GLContext.loadNativeLibraries(null, null, null) == false ) {
        MessageManager.write(this, "can't load native libraries");
        throw new BrickException("can't load native libraries");
      }
  		GLContext.gljNativeDebug = false;
	  	GLContext.gljClassDebug  = false;

      boolean keyPriorityf = false;
      int frmSkp = 0;
      boolean slowf = true, grdf = true, bgefcf = true,
       bgmf = true, sef = true, pingsef = true, joystickf = true;
      for ( int i=0 ; i<args.length ;i++ ) {
        if ( args[i].equals("-keypriority") || args[i].equals("-keyPriority") ) {
          keyPriorityf = true;
        } else if ( args[i].equals("-frameskip") ) {
	        i++;
      	  frmSkp = Integer.parseInt(args[i]);
        } else if ( args[i].equals("-noslow") ) {
      	  slowf = false;
        } else if ( args[i].equals("-nogrd") ) {
	        grdf = false;
        } else if ( args[i].equals("-nobgefc") ) {
      	  bgefcf = false;
        } else if ( args[i].equals("-nobgm") ) {
      	  bgmf = false;
        } else if ( args[i].equals("-nose") ) {
      	  sef = false;
        } else if ( args[i].equals("-nopingse") ) {
      	  pingsef = false;
        } else if ( args[i].equals("-nojoystick") ) {
          joystickf = false;
        }
      }
      new GameManager(keyPriorityf, frmSkp, slowf, grdf, bgefcf,
       bgmf, sef, pingsef, joystickf);
    } catch ( Exception e ) {
      MessageManager.write(this, "game start failed", e);
    }
  }

  public final static void main(String[] args) {
    new Brick(args);
  }
}
