package jp.gr.java_conf.abagames.brick;

import gl4java.*;
import java.util.Random;

/**
  game attract demo
  */
public class DemoManager {
  private GameManager gameManager;
  private BlockManager blockManager;
  private BallManager ballManager;
  private Racket racket;
  private SceneUI sceneUI;

  private Letters cpLtr, ttLtr, blLtr, exLtr;

  public DemoManager(
   GameManager gameManager, BlockManager blockManager, BallManager ballManager,
   Racket racket, SceneUI sceneUI, GLFunc gl) {
    this.gameManager = gameManager;
    this.blockManager = blockManager;
    this.ballManager = ballManager;
    this.racket = racket;
    this.sceneUI = sceneUI;
    cpLtr = new Letters(gl);
    cpLtr.setColor(0.5f, 1, 1);
    ttLtr = new Letters(gl);
    ttLtr.setColor(1, 0.5f, 0.5f);
    blLtr = new Letters(gl);
    blLtr.setColor(1, 1, 1);
    exLtr = new Letters(gl);
    exLtr.setColor(1, 0.9f, 0.9f);
  }

  private void clearLetters() {
    cpLtr.clear();
    ttLtr.clear();
    blLtr.clear();
    exLtr.clear();
  }

  private final int GAMEOVER = 0, OPENING = 1;

  public boolean demof;
  private int cnt, type;

  public void demoStart() {
    demof = true;
    cnt = 0;
    type = OPENING;
    blkTyp = 0;
    gameManager.gameInit();
    blockManager.initDemo();
    blLtr.start("", 3, 3, 0, 0.4f, 0);
    exLtr.start("", 0, 0, 0, 0.3f, 0);
    clearLetters();
  }

  public void gameoverStart() {
    demof = true;
    clearLetters();
    cnt = 0;
    type = GAMEOVER;
  }

  public final void display() {
    if ( cpLtr.exists() ) cpLtr.draw();
    if ( ttLtr.exists() ) ttLtr.draw();
    if ( blLtr.exists() ) blLtr.draw();
    if ( exLtr.exists() ) exLtr.draw();
  }

  private int blkTyp;
  private final String[] blkStr = {
   "NORMAL BLOCK", "COUNTER BLOCK", "SPEED BLOCK",
   "FAN BLOCK", "SPREAD BLOCK", "ETERNITY BLOCK"};
  private final String[] expStr = {
   "SHOOTS A BALL WHEN IT BREAKS",
   "SHOOTS A BALL AT EACH HIT",
   "SHOOTS HIGH SPEED BALLS",
   "SHOOTS FAN-SHAPED BALLS",
   "SHOOTS ROUND-SHAPED BALLS",
   "SHOOTS AN ETERNAL BALL"};

  private int dmStg = -1;
  private int mvCnt, mvDrc;
  private Random rnd = new Random();

  public final void wakeUp() {
    switch ( type ) {
      case OPENING:
        if ( cnt < 120 ) {
          switch ( cnt ) {
            case 30:
              cpLtr.start("BREAK OUT NEXT GENERATION", 0, 8, 0, 0.4f, 999999999);
              break;
            case 60:
              ttLtr.start("_BONG_", 0, 6, 0, 0.6f, 999999999);
              break;
            case 119:
              blkTyp = 0;
              dmStg++; if ( dmStg >= 8 ) dmStg = 0;
              break;
          }
        } else if ( cnt < 1020 ) {
          int mc = (cnt-120)%150;
          switch ( mc ) {
            case 0:
              blockManager.addBlock(6, 10, blkTyp, 3);
              ballManager.addBall(6, -7, 180+36, 0.3f, 1000);
              ballManager.addBall(7, -8, 180+36, 0.3f, 1000);
              ballManager.addBall(8, -9, 180+36, 0.3f, 1000);
              blLtr.set(3, 3, 0.4f);
              blLtr.add(blkStr[blkTyp]);
              blLtr.time = 135;
              break;
            case 70:
              exLtr.set();
              exLtr.add(expStr[blkTyp]);
              exLtr.time = 65;
              break;
            case 135:
              blockManager.clear();
              ballManager.clear();
              blkTyp++; if ( blkTyp >= blkStr.length ) blkTyp = 0;
              break;
          }
          if ( mc < 70 ) {
            blockManager.move();
            ballManager.move();
          }
          blLtr.move();
          exLtr.move();
        } else {
          switch ( cnt ) {
            case 1020:
              gameManager.demoStart();
              cpLtr.clear();
              ttLtr.clear();
              blLtr.set(0, 0, 0.6f);
              blLtr.add("GAME OVER");
              blLtr.time = 1200;
              blockManager.setStageData(dmStg);
              break;
            case 2220:
              demoStart();
              break;
          }
          mvCnt--;
          if ( mvCnt < 0 ) {
            if ( mvDrc == 0 ) {
              if ( racket.x < -8 ) {
                mvDrc = 1;
              } else if ( racket.x > 8 ) {
                mvDrc = -1;
              } else {
                mvDrc = (rnd.nextInt()&1)*2-1;
              }
              mvCnt = 16 + (rnd.nextInt()&31);
            } else {
              mvDrc = 0;
              mvCnt = 8 + (rnd.nextInt()&15);
            }
          }
          switch ( mvDrc ) {
            case -1:
              racket.moveLeft();
              break;
            case 1:
              racket.moveRight();
              break;
          }
          blockManager.move();
          if ( !ballManager.move() ) {
            demoStart();
          }
        }
        if ( sceneUI.lfKey || sceneUI.rtKey || sceneUI.sKey ) {
          demof = false;
          clearLetters();
          gameManager.gameStart();
        }
        break;
      case GAMEOVER:
        switch ( cnt ) {
          case 30:
            blLtr.set(0, 0, 0.6f);
            blLtr.add("GAME OVER");
            blLtr.time = 90;
            break;
          case 120:
            demoStart();
            break;
        }
        break;
    }
    cnt++;
  }
}

