package jp.gr.java_conf.abagames.brick;

import jp.gr.java_conf.abagames.brick.shapes.*;
import jp.gr.java_conf.abagames.util.*;
import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;
import java.util.Random;

/**
  line for flying effect
  */
public class EffectLine extends TrnsObjDSFix {
  private static IShape shape = new EfcLnShape();
  private static Random rnd = new Random();

  private final float MOVE_BOUND = 32;

  public EffectLine(GLFunc gl) {
    super(gl, shape);
    x = rnd.nextFloat()*MOVE_BOUND*((rnd.nextInt()&1)*2-1);
    y = rnd.nextFloat()*MOVE_BOUND*((rnd.nextInt()&1)*2-1);
    z = rnd.nextFloat()*MOVE_BOUND*((rnd.nextInt()&1)*2-1);
  }

  private final float SPEED = 2;

  public final void move() {
    z += SPEED;
    if ( z > MOVE_BOUND ) {
      z -= MOVE_BOUND*2;
    }
  }
}

