package jp.gr.java_conf.abagames.brick;

import jp.gr.java_conf.abagames.brick.shapes.*;
import jp.gr.java_conf.abagames.util.*;
import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;

/**
  Letters Sprite
  */
public class Letters extends TrnsObj implements IMove {
  static public LettersShape ls = new LettersShape();

  public boolean existf;
  public int time;

  public Letters(GLFunc gl) {
    super(gl);
    shape = new ConnectedShape();
    existf = false;
  }

  final private float LTOFS = 1.8f;

  final public Letters start(String text, float x, float y, float z,
   float size, int time) {
    cx = this.x = x; this.y = y; this.z = z;
    xScl = yScl = size;

    ((ConnectedShape)shape).set(LTOFS);
    length = 0;

    add(text);
    this.time = time;
    existf = true;
    return this;
  }

  final public Letters start(String text, float x, float y, float z,
   float d1, float d2, float d3, float size, int time) {
    this.d1 = d1; this.d2 = d2; this.d3 = d3;
    return start(text, x, y, z, size, time);
  }

  public void clear() {
    set();
    existf = false;
  }
  
  public void setColor(float r, float g, float b) {
    ((ConnectedShape)shape).r = r;
    ((ConnectedShape)shape).g = g;
    ((ConnectedShape)shape).b = b;
  }

  private int length;
  private float cx;

  public final void set() {
    ((ConnectedShape)shape).set(LTOFS);
    length = 0;
    existf = true;
  }

  public final void set(float x, float y, float size) {
    set();
    cx = x; this.y = y;
    this.xScl = this.yScl = size;
  }

  public final void add(String text) {
    for ( int i=0 ; i<text.length() ; i++ ) {
      char c = text.charAt(i);
      add(c);
    }
  }

  private int[] nFgrs = new int[16];

  public final void add(int nmb) {
    if ( nmb == 0 ) {
      add('0');
    }
    int lgt = 0;
    for ( ; nmb > 0 ; lgt++, nmb/=10 ) {
      nFgrs[lgt] = nmb%10;
    }
    for ( int i=lgt-1 ; i>=0 ; i-- ) {
      ((ConnectedShape)shape).addShape(ls.shapes[nFgrs[i]]);
    }
    length += lgt;
    x = cx - (length-1)*LTOFS*xScl/2;
  }

  public final void add2(int nmb) {
    ((ConnectedShape)shape).addShape(ls.shapes[nmb/10]);
    ((ConnectedShape)shape).addShape(ls.shapes[nmb%10]);
    length += 2;
    x = cx - (2-1)*LTOFS*xScl/2;
  }

  public final void add(char c) {
    if ( c == ' ' ) {
      ((ConnectedShape)shape).skipChar();
    } else if ( c == '.' ) {
      ((ConnectedShape)shape).addShape(ls.shapes[10+26]);
    } else if ( c == '_' ) {
      ((ConnectedShape)shape).addShape(ls.shapes[10+26+1]);
    } else if ( c == '-' ) {
      ((ConnectedShape)shape).addShape(ls.shapes[10+26+2]);
    } else if ( c >= 'A' ) {
      c -= 'A'-10;
      ((ConnectedShape)shape).addShape(ls.shapes[c]);
    } else {
      c -= '0';
      ((ConnectedShape)shape).addShape(ls.shapes[c]);
    }
    length++;
    x = cx - (length-1)*LTOFS*xScl/2;
  }

  public final void setSize(float size) {
    xScl = yScl = size;
    x = cx - (length-1)*LTOFS*xScl/2;
  }

  final public void move() {
    time--;
    if ( time < 0 ) existf = false;
  }

  final public boolean exists() {
    return existf;
  }
}
