package jp.gr.java_conf.abagames.brick;

import java.io.*;
import java.awt.Rectangle;

/**
  save data manager
  */
public class SaveDataManager {
  private SaveData saveData;

  private void setDefaultData() {
    saveData = new SaveData();
    saveData.sceneUIRect = new Rectangle(0, 0, 640, 480);
    //saveData.frameSkip = 0;
    //saveData.joystickf = true;
    //saveData.bgmf = true;
    //saveData.sef = true;
    saveData.hiscore = 0;
  }

  private byte[] serializeObject(Object obj) throws IOException {
    byte[] bytes;

    ByteArrayOutputStream bo = new ByteArrayOutputStream();
    ObjectOutputStream oo = new ObjectOutputStream(bo);
    oo.writeObject(obj);
    oo.flush();
    bytes = bo.toByteArray();
    oo.close();
    bo.close();
    return bytes;
  }

  private Object deserializeObject(byte[] bytes) throws Exception {
    Object obj;

    ByteArrayInputStream bi = new ByteArrayInputStream(bytes);
    ObjectInputStream oi = new ObjectInputStream(bi);
    try {
      obj = oi.readObject();
    } finally {
      oi.close();
      bi.close();
    }
    return obj;
  }

  public SaveData getSaveData() {
    return saveData;
  }

  private final String saveFilename = "bong.dat";

  public void load() {
    try {
      File fl = new File(saveFilename);
      byte[] b = new byte[(int)fl.length()];
      FileInputStream fis = new FileInputStream(fl);
      fis.read(b);
      saveData = (SaveData)deserializeObject(b);
      fis.close();
    } catch ( Exception e ) {
      setDefaultData();
    }
  }

  public void save() {
    try {
      byte[] b = serializeObject(saveData);
      File fl = new File(saveFilename);
      FileOutputStream fos = new FileOutputStream(fl);
      fos.write(b);
      fos.close();
    } catch ( Exception e ) {}
  }
}

