package jp.gr.java_conf.abagames.brick;

import jp.gr.java_conf.abagames.util.jmf.*;

/*
  sound effects player
  */
public class SePlayer {
  private final String[] SE_FILES = {
    /*"ping", "pong", */"app", "bl_lst", "rdy", "stt",
    "5mn", "3mn", "2mn", "1mn", "30sc", "20sc", "10sc",
    "5sc", "4sc", "3sc", "2sc", "1sc", "0sc"};
  private final String PING_SE_FILE = "ping";
  private final String PONG_SE_FILE = "pong";

  private MdPlayer[] ses;
  private MdPlayer[] ping, pong;
  private boolean sef = true;
  private boolean pingsef = false;

  private final int PP_SE_NMB = 8;//3;
  private int pingIdx, pongIdx;
  private int muteFrameCnt;
  private final int MUTE_FRAME = 1;//4;

  public SePlayer(boolean pingsef) {
    this.pingsef = pingsef;

    ses = new MdPlayer[SE_FILES.length];
    ping = new MdPlayer[PP_SE_NMB];
    pong = new MdPlayer[PP_SE_NMB];
    try {
      for ( int i=0 ; i<SE_FILES.length ; i++ ) {
        ses[i] = new MdPlayer(SE_FILES[i]+".wav");
      }
      for ( int i=0 ; i<PP_SE_NMB ; i++ ) {
        ping[i] = new MdPlayer(PING_SE_FILE+".wav");
        pong[i] = new MdPlayer(PONG_SE_FILE+".wav");
      }
    } catch ( Exception e ) {
      e.printStackTrace();
      sef = false;
    }
  }

  public final void play(int n) {
    if ( !sef ) return;
    if ( n >= 2 ) {
      ses[n-2].play();
    } else {
      if ( !pingsef || muteFrameCnt > 0 ) return;
      muteFrameCnt = MUTE_FRAME;
      switch (n) {
      case 0:
        ping[pingIdx].play();
        pingIdx--; if ( pingIdx < 0 ) pingIdx = PP_SE_NMB-1;
        break;
      case 1:
        pong[pongIdx].play();
        pongIdx--; if ( pongIdx < 0 ) pongIdx = PP_SE_NMB-1;
        break;
      }
    }
  }

  public final void nextFrame() {
    if ( muteFrameCnt > 0 ) {
      muteFrameCnt--;
    }
  }
}

