package jp.gr.java_conf.abagames.brick.shapes;

import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;

/**
  ball shape
  */
public class BallShape implements IShape {
  public static final float SZ = 0.2f;

  private final float[][] vtxs = {
    {-SZ, SZ, -SZ*2}, {SZ, SZ, -SZ*2},
    {-SZ, SZ, 0}, {SZ, SZ, 0},
    {-SZ, -SZ, 0}, {SZ, -SZ, 0},
    {-SZ, -SZ, -SZ*2}, {SZ, -SZ, -SZ*2},
  };

  private float tr, tg, tb, br, bg, bb, sr, sg, sb;

  public BallShape() {
    tr = tg = tb = 1;
    br = bg = bb = 0.5f;
    sr = sg = sb = 0.7f;
  }

  public final void setColor(float r, float g, float b) {
    tr = r; tg = g; tb = b;
    br = r*0.5f; bg = g*0.5f; bb = b*0.5f;
    sr = r*0.7f; sg = g*0.7f; sb = b*0.7f;
  }

  public final void draw(GLFunc gl) {
    gl.glBegin(GLEnum.GL_QUADS);
    gl.glColor3f(br, bg, bb);
    gl.glVertex3fv(vtxs[0]);
    gl.glVertex3fv(vtxs[1]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[1]);
    gl.glVertex3fv(vtxs[7]);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[4]);
    gl.glVertex3fv(vtxs[6]);
    gl.glVertex3fv(vtxs[0]);
    gl.glColor3f(tr, tg, tb);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[4]);
    gl.glColor3f(sr, sg, sb);
    gl.glVertex3fv(vtxs[4]);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[7]);
    gl.glVertex3fv(vtxs[6]);
    gl.glEnd();
  }
}
