package jp.gr.java_conf.abagames.brick.shapes;

import jp.gr.java_conf.abagames.brick.*;
import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;

/**
  block shape
  */
public class BlockShape implements IShape {
  private final float
    LENGTH = BlockManager.BLKWDT*0.9f,
    HEIGHT = 1,
    WIDTH = BlockManager.BLKHGT*0.9f;

  private float[][] vtxs = {
    {0, 0, -HEIGHT}, {LENGTH, 0, -HEIGHT},
    {0, 0, 0}, {LENGTH, 0, 0},
    {0, -WIDTH, 0}, {LENGTH, -WIDTH, 0},
    {0, -WIDTH, -HEIGHT}, {LENGTH, -WIDTH, -HEIGHT},
  };

  private float tr, tg, tb, sr, sg, sb, r, g, b;

  public final void setColor(float r, float g, float b) {
    this.r = r; this.g = g; this.b = b;
    tr = r; tg = g; tb = b;
    sr = r*0.7f; sg = g*0.7f; sb = b*0.7f;
  }

  public final void setBrightness(float br) {
    tr = r+(1-r)*br; tg = g+(1-g)*br; tb = b+(1-b)*br;
    sr = tr*0.7f; sg = tg*0.7f; sb = tb*0.7f;
  }

  public final void draw(GLFunc gl) {
    gl.glBegin(GLEnum.GL_QUADS);
    gl.glColor3f(tr, tg, tb);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[4]);

    if ( ShapeProperties.grdf ) {
    gl.glColor3f(sr, sg, sb);
    gl.glVertex3fv(vtxs[4]);
    gl.glVertex3fv(vtxs[5]);
    gl.glColor3f(0, 0, 0);
    gl.glVertex3fv(vtxs[7]);
    gl.glVertex3fv(vtxs[6]);
    gl.glColor3f(sr, sg, sb);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[3]);
    gl.glColor3f(0, 0, 0);
    gl.glVertex3fv(vtxs[1]);
    gl.glVertex3fv(vtxs[7]);
    gl.glColor3f(sr, sg, sb);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[4]);
    gl.glColor3f(0, 0, 0);
    gl.glVertex3fv(vtxs[6]);
    gl.glVertex3fv(vtxs[0]);
    } else {
    gl.glColor3f(sr, sg, sb);
    gl.glVertex3fv(vtxs[4]);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[7]);
    gl.glVertex3fv(vtxs[6]);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[1]);
    gl.glVertex3fv(vtxs[7]);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[4]);
    gl.glVertex3fv(vtxs[6]);
    gl.glVertex3fv(vtxs[0]);
    }

    gl.glEnd();
  }

  public final void setHeight(float height) {
    vtxs[0][2] = -height; vtxs[1][2] = -height;
    vtxs[6][2] = -height; vtxs[7][2] = -height;
  }
}

