package jp.gr.java_conf.abagames.brick.shapes;

import jp.gr.java_conf.abagames.util.*;
import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;

public class DigitalShape implements IShape {
  private float[][][] vtxs;

  private float[][] indices = new float[6][3];

  public DigitalShape(float[][] spData) {
    makeVtxs(spData);
  }

  private void makeVtxs(float[][] spData) {
    vtxs = new float[spData.length][6][3];
    for ( int i=0 ; i<spData.length ; i++ ) {
      float x = spData[i][0], y = spData[i][1],
       length = spData[i][2]/2, size = spData[i][3]/2;
      int deg = (int)spData[i][4];
      indices[0][0] = -length-size;
      indices[1][0] = -length; indices[1][1] = size;
      indices[2][0] =  length; indices[2][1] = size;
      indices[3][0] =  length+size;
      indices[4][0] =  length; indices[4][1] = -size;
      indices[5][0] = -length; indices[5][1] = -size;
      for ( int j=0 ; j<6 ; j++ ) {
        float
         rx = indices[j][0]*SCTable.cos[deg] - indices[j][1]*SCTable.sin[deg] + x,
         ry = indices[j][0]*SCTable.sin[deg] + indices[j][1]*SCTable.cos[deg] + y;
        vtxs[i][j][0] = rx;
        vtxs[i][j][1] = ry;
      }
    }
  }

  final public void draw(GLFunc gl) {
    for ( int i=vtxs.length-1 ; i>=0 ; i-- ) {
      gl.glBegin(GLEnum.GL_TRIANGLE_FAN);
      gl.glVertex3fv(vtxs[i][0]);
      gl.glVertex3fv(vtxs[i][1]);
      gl.glVertex3fv(vtxs[i][2]);
      gl.glVertex3fv(vtxs[i][3]);
      gl.glVertex3fv(vtxs[i][4]);
      gl.glVertex3fv(vtxs[i][5]);
      gl.glEnd();
    }
  }
}

