package jp.gr.java_conf.abagames.brick.shapes;

import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;

/**
  wall shape
  */
public class WallShape implements IShape {
  public static final float LENGTH = 10, HEIGHT = 5, WIDTH = 0.5f;

  private float[][] vtxs = {
    {-LENGTH, WIDTH, -HEIGHT}, {LENGTH, WIDTH, -HEIGHT},
    {-LENGTH, WIDTH, HEIGHT}, {LENGTH, WIDTH, HEIGHT},
    {-LENGTH, -WIDTH, HEIGHT}, {LENGTH, -WIDTH, HEIGHT},
    {-LENGTH, -WIDTH, -HEIGHT}, {LENGTH, -WIDTH, -HEIGHT},
  };

  public final void draw(GLFunc gl) {
    gl.glBegin(GLEnum.GL_QUADS);

    gl.glColor3f(0.9f, 0.9f, 0.9f);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[4]);

    if ( ShapeProperties.grdf ) {
    gl.glColor3f(0.8f, 0.8f, 0.8f);
    gl.glVertex3fv(vtxs[4]);
    gl.glVertex3fv(vtxs[5]);
    gl.glColor3f(0, 0, 0);
    gl.glVertex3fv(vtxs[7]);
    gl.glVertex3fv(vtxs[6]);
    } else {
    gl.glColor3f(0.4f, 0.4f, 0.4f);
    gl.glVertex3fv(vtxs[4]);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[7]);
    gl.glVertex3fv(vtxs[6]);
    }

    gl.glEnd();
  }

  public void setLength(float length) {
    for ( int i=0 ; i<8 ; i+=2 ) {
      vtxs[i][0] = -length;
    }
    for ( int i=1 ; i<8 ; i+=2 ) {
      vtxs[i][0] = length;
    }
  }
}
