package jp.gr.java_conf.abagames.util.gl4j;

import gl4java.GLFunc;

/**
  OpenGL position handler
  */
public class TrnsObj {
  public float x, y, z, d1, d2, d3;
  public float xScl, yScl;

  private GLFunc gl;
  public IShape shape;

  public TrnsObj(GLFunc gl, IShape shape) {
    this(gl);
    this.shape = shape;
  }

  public TrnsObj(GLFunc gl) {
    this.gl = gl;
    xScl = yScl = 1;
  }

  public final void draw() {
    gl.glPushMatrix();
    gl.glTranslatef(x, y, z);
    gl.glRotatef(d1, 0, 1, 0);
    gl.glRotatef(d2, 1, 0, 0);
    gl.glRotatef(d3, 0, 0, 1);
    gl.glScalef(xScl, yScl, 1.0f);
    shape.draw(gl);
    gl.glPopMatrix();
  }
}

