package jp.gr.java_conf.abagames.util.jmf;

import javax.media.*;

/**
  JMF media player
  */
public class MdPlayer implements ControllerListener {
  private Player player;

  public MdPlayer(String filename) throws Exception {
    MediaLocator mrl = new MediaLocator(
     "file:///"+System.getProperty("user.dir")+"\\"+filename);
    player = Manager.createPlayer(mrl);
    player.addControllerListener(this);
    player.realize();
  }

  private boolean loopf = false;

  public MdPlayer(String filename, boolean loopf) throws Exception {
    this(filename);
    this.loopf = loopf;
  }

  private boolean prefetched = false;
  private boolean startf = false;

  public void play() {
    if ( prefetched ) {
      //player.setMediaTime(zeroTime);
      player.start();
    } else {
      startf = true;
    }
  }

  public void stop() {
    player.stop();
  }

  public void setZeroTime() {
    player.setMediaTime(zeroTime);
  }

  public void close() {
    player.stop();
    player.deallocate();
    player.close();
  }

  private Time zeroTime = new Time(0);

  public synchronized void controllerUpdate(ControllerEvent ce) {
    if ( ce instanceof RealizeCompleteEvent ) {
      player.prefetch();
    } else if ( ce instanceof PrefetchCompleteEvent ) {
      prefetched = true;
      if ( startf ) {
        player.start();
        startf = false;
      }
    } else if ( ce instanceof EndOfMediaEvent ) {
      player.setMediaTime(zeroTime);
      if ( loopf ) {
        player.start();
      }
    }
  }
}

